#define FILEX fd
#include "eric.h"
#include "jplclib.h"
#include "files.h"


        extern long falloc();
        extern int putc();
        extern putat();
        extern getat();


function initf(fd,size)  register FILE *fd; long size;   {
        register int i;
	long l;
        struct filefl ini;
        seekl(fd,0l);
/*
/
/    The below are contiguous structures on disk. Spacing is for
/    readability only.
/
/              ----------------------
/              |extend size of file |
/              ----------------------
/              |pointer to eof      |
/              ----------------------
/
/              ----------------------
/ AVAIL ->     |          0         |
/              ----------------------
/              |pointer to 1st block|  >-----|   initially
/              ----------------------        |
/                                            |
/              ----------------------        |
/              |size of block       |  <-----|
/              ----------------------
/              |pointer to next free|            NIL  initially
/              ----------------------
/
/*/
	for upto(i,0,010000,1)
	    putc(-1,fd);    /*  clear a file to all bits on  */
        rof

        l=AVAIL+2*SLONG;
        ini.floc  = NIL;   /*  but only free block  */
        ini.fsize = size;  /*  set up first free block, Size = size  */
        putat(fd,l,&ini,sizeof(ini));

        ini.floc  = l;     /*  init avail listhead; point to 1st free block  */
        ini.fsize = 0l;    /*  listhead always is of size 0  */
        putat(fd,AVAIL,&ini,sizeof(ini));

        l=AVAIL-2*SLONG;
        ini.fsize = size;                         /*  set extend file size  */
        ini.floc  = AVAIL+size+SLONG*2;    /*  set eof  */
        putat(fd,l,&ini,sizeof(ini));
        }

/*
/
/   Following  are  two  routines for dynamic allocation of space in a
/   file. They are essentially algoritms  A  and  B  of  KNUTH  vol  1
/   section  2.5.  Algorithm  A    has a rover modification as well as
/   step A4' (see following page in KNUTH).
/
/   In short, first fit with a rover; smallest granule size is MINIMUM
/   (i.e. round up to next multiple of MINUMIM ) and free  list  holes
/   never  less  than  SMALL. I think a power of 2 is best here. Also,
/   the algorithm may not work correctly for MINUMIM  and  SMALL  less
/   than 8 .
/
/*/


function long falloc(fd,n) FILE *fd; long n; {

        static long rover = {AVAIL};
        long eof,neweof,size,p,q,l,k;
	struct filefl scr1,scr2;
	register struct filefl *q1 ,*p1 ;
	struct filefl scr3;
	register struct filefl *x1;
        int flag;

        n=n+(SLONG+MINIMUM-1); n=n/MINIMUM ; n=n*MINIMUM;
        q1 = &scr1; p1 = &scr2;
        q=rover;
        flag=0;
        forever
            getstruct(q,q1);
            p=q1->floc;
            if (p==NIL) then
                if (flag==0) then
                    q=AVAIL;
                    flag++;
                    continue;
                els
                    q=rover; flag=0;
                    getstruct(AVAIL-2*SLONG,q1);
                    size=q1->fsize; eof=q1->floc;
		    x1 = &scr3;   x1->fsize = size;  x1->floc = 0l;
                    putstruct(eof,x1);
                    neweof=size+eof;
                    putat(fd,AVAIL-SLONG,&neweof,SLONG);
                    ffree(fd,eof+SLONG);
                    continue;
                fi
            fi
            getstruct(p,p1);
            if ((p1->fsize)>=n) then
                break;
            els
                q=p;
            fi
        rof
        k= (p1->fsize) - n;
        if (k<SMALL) then
            q1->floc = p1->floc;
            l=p;
            putstruct(q,q1);
        els
            p1->fsize=k;
            l=p+k;
            putstruct(p,p1);
            putat(fd,l,&n,sizeof(n));
        fi
        getat(fd,q+SLONG,&rover,SLONG);
        if (rover==0) then
            rover = AVAIL;
        fi
        return l+SLONG;
        }


function long ffree(fd,po) FILE *fd; long po; {
        long p,q,n;
	struct filefl scr1,scr2,scr3;
	register struct filefl  *q1,*p1,*po1;

        q = AVAIL;
        po = po - SLONG;

        q1 = &scr1; po1 = &scr2; p1 = &scr3;
        getat(fd,po,&n,SLONG);

        forever
            getstruct(q,q1);
            p=q1->floc;
            if (p==NIL or p>po) then
                break;
            els
                q=p;
            fi
        rof
        if ((po+n) == p) then
            getstruct(p,p1);
            n=n+p1->fsize;
            po1->floc = p1->floc;
        els
            po1->floc = p;
        fi

        if ((q+q1->fsize) == po) then
            q1->fsize = q1->fsize + n;
            q1->floc  = po1->floc;
        els
            q1->floc = po;
            po1->fsize = n;
        fi
        putstruct(q,q1);
        putstruct(po,po1);
        return;
        }
